// This file is released under the 3-clause BSD license. See COPYING-BSD.


function rst_callback()
    global sys_edit;
    global te_edit;
    global tfstep_edit;
    global n1_edit;
    global n2_edit;
    global nu_edit;
    global lambda_edit;
    printf('\nGenerating RST controler...\n');
    linear_sys = eval(sys_edit.string)
    Te = strtod(te_edit.string);
    Tfstep = strtod(tfstep_edit.string);
    N1 = strtod(n1_edit.string);
    N2 = strtod(n2_edit.string);
    Nu = strtod(nu_edit.string);
    Lambda = strtod(lambda_edit.string);
    [R, Sfinal, T, Hboc] = compute_predictive_rst(linear_sys, Te, Tfstep, N1, N2, Nu, Lambda);
endfunction

function simulate_callback()
    disp('Simulating RST controler...');
    xcos_predictivepath = atomsGetLoadedPath("predictivemodule");
    xcos(xcos_predictivepath + filesep() + "demos" + filesep() + "predictive_rst.zcos")
endfunction

function predictive_gui()
    global sys_edit;
    global te_edit;
    global tfstep_edit;
    global n1_edit;
    global n2_edit;
    global nu_edit;
    global lambda_edit;
    fig=figure(1,'figure_name','Predictive controler setup','position',[0 0 220 303],'Backgroundcolor',[1.000000 1.000000 1.000000],"infobar_visible", "off", "toolbar_visible", "off", "dockable", "off", "menubar", "none");
    h(1)=uicontrol(fig,"Position",[12 246 89 24],"Style","text","string","System name","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    sys_edit=uicontrol(fig,"Position",[113 246 89 24],"Style","edit","string","linear_sys","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    h(2)=uicontrol(fig,"Position",[12 216 89 24],"Style","text","string","Time sampling in seconds","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    te_edit=uicontrol(fig,"Position",[113 216 89 24],"Style","edit","string","0.1","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    h(3)=uicontrol(fig,"Position",[12 186 89 24],"Style","text","string","Stationnary","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    tfstep_edit=uicontrol(fig,"Position",[113 186 89 24],"Style","edit","string","5.0","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    h(4)=uicontrol(fig,"Position",[12 156 89 24],"Style","text","string","N1","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    n1_edit=uicontrol(fig,"Position",[113 156 89 24],"Style","edit","string","6","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    h(5)=uicontrol(fig,"Position",[12 126 89 24],"Style","text","string","N2","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    n2_edit=uicontrol(fig,"Position",[113 126 89 24],"Style","edit","string","15","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    h(6)=uicontrol(fig,"Position",[12 96 89 24],"Style","text","string","Nu","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    nu_edit=uicontrol(fig,"Position",[113 96 89 24],"Style","edit","string","3","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    h(7)=uicontrol(fig,"Position",[12 66 89 24],"Style","text","string","Lambda","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    lambda_edit=uicontrol(fig,"Position",[113 66 89 24],"Style","edit","string","0.000001","Horizontalalignment","left","Fontsize",12,"Backgroundcolor",[0.900000 0.900000 0.900000 ]);
    h(7)=uicontrol(fig,"Position",[12 36 89 24],"Style","pushbutton","string","Generate RST controler","callback","rst_callback","Horizontalalignment","center","Fontsize",12);
    h(8)=uicontrol(fig,"Position",[113 36 89 24],"Style","pushbutton","string","Simulate","callback","simulate_callback","Horizontalalignment","center","Fontsize",12);
endfunction
